/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.entity;

import java.util.Set;

import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.JoinTable;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
@Entity(name = "AdminUserEntity")
@Table(name = "adminusertable")
public class AdminUserEntity extends AbstractBaseEntity {

	private static final long serialVersionUID = 1L;
	
	@Column(name = "username", length = 256, unique = true, nullable = false)
	private String username;
	
	@Column(name = "password", length = 256, nullable = false)
	@Getter
	@Setter
	private String password;
	
	@Column(name = "description", length = 512)
	private String description;
	
	@ManyToMany(targetEntity=RoleEntity.class, cascade = CascadeType.ALL)
	@JoinTable(name = "adminuser_role",
			joinColumns = @JoinColumn(name="admin_user_id"),
			inverseJoinColumns = @JoinColumn(name="role_id")
	)
	private Set<RoleEntity> roles;	
}
