package edu.kit.scc.webreg.dto.mapper;

import edu.kit.scc.webreg.dto.entity.IdentityEntityDto;
import edu.kit.scc.webreg.entity.identity.IdentityEntity;
import jakarta.enterprise.context.ApplicationScoped;

@ApplicationScoped
public class IdentityEntityMapper extends AbstractBaseEntityMapper<IdentityEntity, IdentityEntityDto> {

	private static final long serialVersionUID = 1L;

	@Override
	protected void copyAllProperties(IdentityEntity fromBaseEntity, IdentityEntityDto toDtoEntity) {

		toDtoEntity.setTwoFaUserName(fromBaseEntity.getTwoFaUserName());
		toDtoEntity.setUidNumber(fromBaseEntity.getUidNumber());
		toDtoEntity.setPrefUserId(fromBaseEntity.getPrefUser().getId());

	}

	@Override
	public Class<IdentityEntityDto> getEntityDtoClass() {
		return IdentityEntityDto.class;
	}

	@Override
	protected String[] getPropertiesToCopy() {
		return new String[] { "twoFaUserName", "prefUserId", "uidNumber" };
	}

}