package edu.kit.scc.webreg.health;

import java.util.Date;
import edu.kit.scc.webreg.dto.entity.HealthCheckResponseDto;
import edu.kit.scc.webreg.service.disco.DiscoveryCacheSingleton;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.Produces;

import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;

@Path("/check")
@ApplicationScoped
public class HealthCheckRestController {

	@Inject
	private DiscoveryCacheSingleton singleton;

	@GET
	@Path("/live")
	@Produces("application/json")
	public Response getLiveness() {

		HealthCheckResponseDto dto = new HealthCheckResponseDto();

		long lastRefresh = singleton.getLastRefresh();
		
		String status = (lastRefresh == 0L) ? "Down" : "Up";
		dto.setStatus(status);

		dto.setName("RegApp Liveness Health Check");
		dto.setLastRun(new Date(lastRefresh));

		return Response.ok(dto).build();

	}

	@GET
	@Path("/ready")
	@Produces("application/json")
	public Response getReadiness() {

		HealthCheckResponseDto dto = new HealthCheckResponseDto();

		long lastRefresh = singleton.getLastRefresh();
		
		String status = (lastRefresh == 0L) ? "Down" : "Up";
		dto.setStatus(status);

		dto.setName("RegApp Readiness Health Check");
		dto.setLastRun(new Date(lastRefresh));

		return Response.ok(dto).build();

	}

}
